import { Observer, Unsubscribable } from "rxjs"
import { AdapterInterface, AdapterManagerInterface, TransportService, TransportSet } from "../interface/interface"
import { ActorInterface, ActorProfile } from "../interface/actor.interface"
import { ActorBase } from "../base/actor.base"

export class AdapterManagerBase<T> extends ActorBase<T> implements AdapterManagerInterface<T> {
    protected transportServiceArray: TransportService[] = []
    protected transportSet: TransportSet[] = []
    protected adapters: AdapterInterface[] = []

    constructor() {
        super()
    }

    public subscribe(actorProfile: ActorProfile, observer: Partial<Observer<T>>, subscribable?: ActorInterface<T>): Unsubscribable {
        throw new Error("Method not implemented.");
    }


}



