
import { Observable, Observer, Subject, Unsubscribable } from 'rxjs';
import { MessageTransmissionManagerInterface, Transmission } from '../interface/interface';
import { ActorInterface, ActorProfile } from '../interface/actor.interface';
import { ActorBase } from './actor.base';
import { AdapterManager } from '../connector/adapter.manager';

export class MessageTransmissionManagerBase<T> extends ActorBase<T> implements MessageTransmissionManagerInterface<T> {
    protected browserEnv!: boolean
    protected transmissionSet: Transmission[] = []
    protected adapterManager!: AdapterManager

    constructor() {
        super()
    }

    public subscribe(actorProfile: ActorProfile, observer: Partial<Observer<T>>, subscribable?: ActorInterface<T>): Unsubscribable {
        throw new Error("Method not implemented.");
    }

    protected instantiateTransmissionComponents(clientId: string): Transmission {
        throw new Error(`Method not implemented`)
        /* Subscribe to adapterEvent, adapter will give adapter with the relevant client information. 
        It will first check array of transmission clinetID, so if new clientId is detected then a new 
        transmission set will be instantiated. Then an observable instance for each transmission components
        will be attacked to each of the transmission componetns, so that the respective transmission 
        can handle more or less of the adapters instantiated by the adapter manager based on the new
        adapters or it ohter cases, terminating of adaptesr as well. */
    }
}